# 插件使用说明

## 1. 发布为nexus raw仓库来使用

1. 上传`standalone-worker.min.js` 到 `/lowcode-code-generator-ccs@0.1.0/dist/`路径

2. 打开nexus域名跨域

```yaml
  annotations:
    nginx.ingress.kubernetes.io/enable-cors: 'true'
    nginx.ingress.kubernetes.io/ingress.class: nginx
```
3. 使用地址 workerJsUrl => `nexus.xxx/repository/unpkg/lowcode-code-generator-ccs@0.1.0/dist/standalone-worker.min.js`

## 2. 本地使用 

1. 拷贝 `scripts\lowcode-code-generator-ccs@0.1.0\dist\standalone-worker.min.js` 到 `public/lowcode-code-generator-ccs@0.1.0\dist\standalone-worker.min.js`

2. 使用地址 workerJsUrl => `lowcode-code-generator-ccs@0.1.0/dist/standalone-worker.min.js`

## 给插件和按钮增加属性 workerJsUrl

```ts
export type CodeGenPluginOptions = {
  /** 是否要禁用出码的动作按钮(默认: 否) */
  disableCodeGenActionBtn?: boolean;
  /**'http://nexus.c7n.gzinfo/repository/unpkg/lowcode-code-generator-ccs@0.1.0/dist/standalone-worker.min.js' */
  workerJsUrl?: string;
};

... 通过插件给按钮透传属性 
 content: CodeGenActionBtn,
 contentProps: { ctx, workerJsUrl: options.workerJsUrl },

... 直接给按钮传属性
 <CodeGenActionBtn ctx={ctx} workerJsUrl={workerJsUrl}/>
```

