import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import * as CodeGenerator from 'lowcode-code-generator-ccs/standalone-loader';
import { CodeGenActionBtn } from './components/CodeGenActionBtn';
var CodeGeneratorPlugin = function CodeGeneratorPlugin(ctx, options) {
  return {
    // 插件对外暴露的数据和方法
    exports: function exports() {
      return {
        generateCode: CodeGenerator.generateCode
      };
    },
    // 插件的初始化函数，在引擎初始化之后会立刻调用
    init: function init() {
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee() {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                console.log(options.workerJsUrl);
                _context.prev = 1;
                if (!(options !== null && options !== void 0 && options.disableCodeGenActionBtn)) {
                  ctx.skeleton.add({
                    type: 'Custom',
                    name: 'CodeGenerator',
                    area: 'topArea',
                    props: {
                      align: 'right',
                      width: 100
                    },
                    content: CodeGenActionBtn,
                    contentProps: {
                      ctx: ctx,
                      workerJsUrl: (options === null || options === void 0 ? void 0 : options.workerJsUrl) || 'lowcode-code-generator-ccs@0.1.0/dist/standalone-worker.min.js'
                    }
                  });
                }
                // 提前初始化下，这样后面用的时候更快
                CodeGenerator.init({
                  workerJsUrl: (options === null || options === void 0 ? void 0 : options.workerJsUrl) || 'lowcode-code-generator-ccs@0.1.0/dist/standalone-worker.min.js'
                });
                _context.next = 10;
                break;
              case 6:
                _context.prev = 6;
                _context.t0 = _context["catch"](1);
                console.error('[plugin-code-geneator] failed to init: ', _context.t0);
                throw _context.t0;
              case 10:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[1, 6]]);
      }))();
    },
    destroy: function destroy() {}
  };
};
CodeGeneratorPlugin.pluginName = 'CodeGenerator';
CodeGeneratorPlugin.meta = {
  preferenceDeclaration: {
    //不能少,不然不能传入进参数
    title: 'plugin CodeGenerator 参数定义',
    properties: [{
      key: 'disableCodeGenActionBtn',
      type: 'boolean',
      description: 'this is description for key2'
    }, {
      key: 'workerJsUrl',
      type: 'string',
      description: 'this is description for key1'
    }]
  },
  dependencies: [],
  engines: {
    lowcodeEngine: '^1.0.10' // 插件需要配合 ^1.0.10 的引擎才可运行
  }
};

export { CodeGenActionBtn, CodeGeneratorPlugin };